package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-23 15:53
 * @Modify:
 **/
public class WmsEnumUtil {

    /**
     * 拆分规则
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SPLIT_OR_MERGE_RULE {
        WH(10, "WH", "仓库"), ZONE(20, "ZONE", "存储区"), PART(30, "PART", "物料");
        private int value;
        private String code;
        private String description;

        SPLIT_OR_MERGE_RULE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 订单明细信息 是否免费
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum IS_FREE {
        CHARGING(1, "计费"), GRATIS(2, "免费");

        private int value;
        private String description;

        IS_FREE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 移库单主表：优先级
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PRIORITY {
        NORMAL(1, "正常"), URGENT(2, "紧急");
        private int value;
        private String description;

        PRIORITY(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 订单明细信息 状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_DETAILS_STATUS {
        NORMAL(10, "N", "正常"),
        RECEIPTED(20, "R", "已完成"),
        ANCEL(30, "C", "行取消");

        private int value;
        private String code;
        private String description;

        ORDER_DETAILS_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 主表信息 单据来源
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_SRC {
        MNU(10, "MNU", "手工"),
        ERP(20, "ERP", "ERP接口");

        private int value;
        private String code;
        private String description;

        ORDER_SRC(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 主表信息 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_TYPE {
        REG(10, "REG", "原物料采购"),
        SUB(20, "SUB", "委外采购"),
        TAR(30, "TAR", "多角贸易采购"),
        TAP(40, "TAP", "多角代采购");

        private int value;
        private String code;
        private String description;

        ORDER_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 移库单主表状态；质检单主表状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MASTER_ORDER_STATUS {
        CREATE(10, "新建"),
        RECEIPT(20, "处理中"),
        RECEIPT_FINISH(30, "已完成"),
        CLOSED(40, "已关闭"),
        CANCELLED(50, "已取消");

        private int value;
        private String description;

        MASTER_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 收货主表信息 状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_ORDER_STATUS {
        CREATE(10, "新建"),
        RECEIPT(20, "收货中"),
        RECEIPT_FINISH(30, "收货完成"),
        CLOSED(40, "已关闭"),
        CANCELLED(50, "已取消");

        private int value;
        private String description;

        RC_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * PO条码状态信息
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SN_DETAILS_STATUS {
        CREATE(10, "新建"),
        WAREHOUSING(30, "已打印"),
        RECEIPT_FINISH(20, "已收货");

        private int value;
        private String description;

        SN_DETAILS_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 消息队列，队列名称
     * 1: success_queue
     * 2: fail_queue
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QUEUE_NAME {

        SUCCESS_QUEUE(1, "wms_success_queue", "成功消息队列"),
        PENDING_QUEUE(2, "wms_pending_queue", "待处理消息队列");

        private int value;
        private String name;
        private String description;

        QUEUE_NAME(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 产品入库的产品状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PRODUCT_INSTOCK_STATUS {
        CREATE(10, "创建"), FINISH(20, "已处理"), FAIL(30, "处理出错");

        private int value;
        private String description;

        PRODUCT_INSTOCK_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 库位类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum LOCATE_TYPE {
        COLLECT_LOCATE(10, "I", "收货库"),
        BASICS_LOCATE(20, "P", "基础库"),
        MANEUVER_LOCATE(30, "R", "机动库"),
        COMBINATION_LOCATE(40, "D", "组合库"),
        LINE_LOCATE(50, "L", "线边库"),
        NC_LOCATE(60, "N", "NC库"),
        SPILLAGE_LOCATE(70, "Y", "溢料库"),
        TRANSIT_LOCATE(80, "T", "在途库");

        private int value;
        private String code;
        private String description;

        LOCATE_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 库位状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum LOCATE_STATUS {
        CREATE(10, "空库位"), FINISH(20, "非空"), FAIL(30, "已满");

        private int value;
        private String description;

        LOCATE_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单移动类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_MOVE_TYPE {
        IN_STORE(10, "IN", "入库"),
        OUT_STORE(20, "OUT", "出库"),
        MOVE_STORE(30, "MOVE", "移库");

        private int value;
        private String code;
        private String description;

        OUT_MOVEMENT_MOVE_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 移库单业务类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_BUSI_TYPE {
        PRODUCTION_MATERIAS(10, "PROD_MATERIALS", "生产领料"),
        CUSTOMER_SHPING(20, "CUS_SHPING", "客户发运"),
        OUTWARD_SHIPMENT(30, "OUT_SHIPMENT", "委外发运"),
        ALLOCATION(40, "ALLOCATION", "调拨"),
        SCATTERED_OUT(50, "SCATTERED_OUT", "零星出库"),
        SCATTERED_IN(60, "SCATTERED_IN", "零星入库"),
        NC_WAREHOSING_IN(70, "NC_WAREHOSING", "NC入库"),
        SUPPLIER_RETURN(80, "SUPPLIER_RETURN", "供应商退货"),
        CUSTOMER_RETURN(90, "CUSTOMER_RETURN", "客户退货"),
        PRODUCT_RETURN(100, "PRODUCT_RETURN", "生产退料"),
        INSTRUCTION_MOVE(110, "INSTRUCTION_MOVE", "指令移库"),
        SCRAPPING_OUT(120, "SCRAPPING_OUT", "报废出库"),
        RECEIVING_IN(130, "RECEIVING_IN", "收货入库"),
        OUTSOURCING_BACK(140, "OUTSOURCING_BACK", "委外退回"),
        NC_WAREHOSING_OUT(150, "NC_WAREHOSING_OUT", "NC出库");

        private int value;
        private String code;
        private String description;

        OUT_MOVEMENT_BUSI_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }


    /**
     * 物料：分类（ABC）
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PART_ABC {
        A(1, "A"),
        B(2, "B"),
        C(3, "C"),
        D(4, "D"),
        E(5, "E");

        private int value;
        private String description;

        PART_ABC(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_MASTER_ORDER_TYPE {
        ORDER_PULL_PART(1, "工单配料");

        private int value;
        private String description;

        OUT_MOVEMENT_MASTER_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 外部单据：移库单关联单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OUT_MOVEMENT_MASTER_LINK_ORDER_TYPE {
        ASN(10, "ASN", "ASN"),
        PO(20, "PO", "PO"),
        SO(30, "SO", "SO"),
        MOVE(40, "MOVE", "MOVE"),
        IN_STOCK(50, "IN_STOCK", "IN_STOCK"),
        SHIPPING(60, "SHIPPING", "SHIPPING"),
        QC(70, "QC", "QC"),
        CS(80, "CS", "CS");
        private int value;
        private String code;
        private String description;

        OUT_MOVEMENT_MASTER_LINK_ORDER_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static OUT_MOVEMENT_MASTER_LINK_ORDER_TYPE codeOf(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    return values()[i];
                }
            }
            return null;
        }
    }

    /**
     * 作业任务状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TASK_INFO_STATUS {
        CREATE(10, "创建"), FINISH(20, "处理中"), FAIL(30, "已处理");

        private int value;
        private String description;

        TASK_INFO_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 单据是否生成任务状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum IS_GENERAL_TASK {
        CREATE(10, "创建"), INIT(20, "初始化"), IS_GENERAL(30, "已生成"), NO_GENERAL(40, "不生成");

        private int value;
        private String description;

        IS_GENERAL_TASK(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * ASN单据状态 10=新建,20=收货中,30=收货完成，40=已关闭,50=已取消
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ASN_STATUS {

        CREATE(10, "新建"),
        RECEIPT(20, "收货中"),
        RECEIPT_FINISH(30, "收货完成"),
        CLOSED(40, "已关闭"),
        CANCELLED(50, "已取消");

        private int value;
        private String description;

        ASN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }


    /**
     * 业务表：库存条码状态
     * 1=创建，10=质检中，20=待入库，30=入库，40=配料，50=出库，60=报废，70=在途
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum STOCK_SN_STATUS {
        CREATE(1, "创建"),
        QUALITY_CONTROL(10, "质检中"),
        PRE_INSTOCK(20, "待入库"),
        INSTOCKED(30, "入库"),
        PICKED(40, "配料"),
        OUT_STOCK(50, "出库"),
        FRAZE(60, "报废"),
        COMMING(70, "在途");

        private int value;
        private String description;

        STOCK_SN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 业务表：库存条码质检状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum STOCK_SN_QC_STATUS {
        NORMAL(10, "NORMAL", "合格"), ABNORMAL(20, "ABNORMAL", "不合格"), ISOLATED(30, "ISOLATED", "隔离");

        private int value;
        private String code;
        private String description;

        STOCK_SN_QC_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
        public static STOCK_SN_QC_STATUS codeOf(Integer value) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == value) {
                    return values()[i];
                }
            }
            return null;
        }
    }

    /**
     * 盘点主表 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_ORDER_TYPE {
        DAY_INVENTORY(10, "日常盘点"),
        MONTH_INVENTORY(20, "月度盘点"),
        SEASON_INVENTORY(30, "季度盘点"),
        YEAR_INVENTORY(40, "年度盘点");

        private int value;
        private String description;

        CS_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点主表 盘点状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_ORDER_STATUS {
        CREATE(10, "创建"),
        STARTING_INVENTORY(20, "开启盘点"),
        IN_INVENTORY(30, "盘点中"),
        INVENTORY_FINISH(40, "盘点完成"),
        THAWING(50, "已解冻"),
        CLOSED(60, "已关闭");

        private int value;
        private String description;

        CS_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点冻结 处理状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_TRANS_STATUS {
        CREATE(10, "已创建"),
        INVENTORY(20, "已盘"),
        FROZEN(30, "已冻结"),
        THAWING(40, "已解冻"),
        RETURN_GOODS(50, "取消冻结");

        private int value;
        private String description;

        CS_TRANS_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 盘点实盘 处理状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum CS_ITEM_STATUS {
        CREATE(1, "创建"), FINISH(10, "已处理");

        private int value;
        private String description;

        CS_ITEM_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 库存移动单状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MOVE_ORDER_STATUS {
        CREATE(10, "创建"),
        BE_HANDLE(20, "待处理"),
        FINISH(30, "已处理"),
        HANDLE_ERROR(40, "处理出错");

        private int value;
        private String description;

        MOVE_ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 库存移动单明细状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MOVE_DETAIL_STATUS {
        CREATE(10, "创建"),
        BE_HANDLE(20, "待处理"),
        FINISH(30, "已处理");

        private int value;
        private String description;

        MOVE_DETAIL_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 质检业务类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_INFO_TYPE {
        FEED(10, "进料检验"),
        ONLINE(20, "在线检验"),
        EMDPRODUCT(30, "成品检验"),
        SHIPMENTS(40, "出货检验");

        private int value;
        private String description;

        QC_INFO_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 质检业务状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_INFO_STATUS {
        CREATE(10, "新建"),
        FINISH(20, "处理中"),
        FAIL(30, "已完成"),
        CLOSE(40, "已关闭"),
        CANCEL(50, "已取消");

        private int value;
        private String description;

        QC_INFO_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 质检明细转态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QC_ITEM_STATUS {
        NORMAL(1, "正常"),
        CANCELLATION(10, "行取消");

        private int value;
        private String description;

        QC_ITEM_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业记录参数状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ALD_EXECUTE_STATUS {
        NORMAL(10, "创建"),
        PROCESSING(20, "处理中"),
        COMPLETED(30, "已完成");
        private int value;
        private String description;

        ALD_EXECUTE_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业流程动作类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_GROUP_DETAILS_VALUE_TYPE {
        ONETIMEONLY(10, "只输入一次"),
        MANYTIME(20, "输入多次"),
        MAYTIMEUNIQUE(30, "输入多次不允许重复"),
        ACTIONFINISH(40, "本流程结束");

        private int value;
        private String description;

        ACTION_GROUP_DETAILS_VALUE_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 作业步骤处理组件参数类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_MOUDULE_PARAM_TYPE {
        CHECKLIST(1, "可选列表"),
        NUMBER(10, "数字"),
        STRING(20, "字符串"),
        OUT_OR_UNNECESSARY(30, "出参或者不必需的参数");

        private int value;
        private String description;

        ACTION_MOUDULE_PARAM_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组件扫描单号 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_ORDER_TYPE {
        PO(10, "PO"),
        ASN(20, "ASN");

        private int value;
        private String description;

        RC_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 打印单号数据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PRINT_ORDER_TYPE {
        PO(10, "PO"),
        MOVEMENT(20, "MOVEMENT"),
        ASN(30, "ASN");

        private int value;
        private String description;

        PRINT_ORDER_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组件统一返回提示
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_RESPONSE_TIPS {

        OK(1, true, "正确"),
        NG(2, false, "失败");

        private int value;
        private boolean codeStatus;
        private String description;

        RC_RESPONSE_TIPS(int value, boolean codeStatus, String description) {
            this.value = value;
            this.codeStatus = codeStatus;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public boolean getCodeStatus() {
            return codeStatus;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 流程管家中触发源
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ACTION_BUTLER_SOURCE {

        SCANNER(10, "扫描枪"),
        SUBMIT(20, "提交按钮"),
        RESET(30, "重置按钮"),
        CHECK_DETAILS(40, "查看明细"),
        DELETE_DETAILS(50, "明细(删除)"),
        CLEAR_DETAILS(60, "明细（清空）"),
        CUSTOM_BUTTON(70, "自定义按钮");

        private int value;
        private String description;

        ACTION_BUTLER_SOURCE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * PO条码表条码状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PO_SN_STATUS {

        FOUND(10, "创建"),
        PRINTED(20, "已打印"),
        RECEIPTED(30, "已收货");

        private int value;
        private String description;

        PO_SN_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 组件类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum COMPONENT_TYPE {

        PROCESS_HANDLING(10, "流程处理组件,"),
        PROCESS_INITIALIZATION(20, "流程初始化组件"),
        PROCESS_END(30, "流程结束组件"),
        DETAIL_PROCESS(40, "明细处理组件"),
        BACK_DISPLAY(50, "回显方法");

        private int value;
        private String description;

        COMPONENT_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 条码类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SN_TYPE {
        ONE_DIMENSIONAL_CODE(10, "1D"),
        QR_CODE(20, "2D"),
        ALL(30, "ALL");

        private int value;
        private String description;

        SN_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 流程明细动作类型
     * 10=交互动作,20=后台动作,30=提交动作
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum GROUP_VALUE_TYPE {

        INTERACTIVE_ACTION(10, "交互动作"),
        BACKSTAGE_ACTION(20, "后台动作"),
        SUBMIT_ACTION(30, "提交动作"),
        SELECT_ACTION(40, "选择动作");

        private int value;
        private String description;

        GROUP_VALUE_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 成功标志枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum RC_OK_VALUE {

        IS_TRUE(10, true, "成功"),
        IS_FALSE(20, false, "失败");

        private int value;
        private boolean codeValue;
        private String description;

        RC_OK_VALUE(int value, boolean codeValue, String description) {
            this.value = value;
            this.codeValue = codeValue;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public boolean getCodeValue() {
            return codeValue;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 通用序号编码枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum COMMON_SEQ {
        TASK_MV_ORDERNO("TASK_MV_ORDERNO", "作业任务移动单号"),
        ROUTING_SEQ("ROUTING_SEQ", "物料路线序号"),
        LOCATE_SEQ("LOCATE_SEQ", "库位序号"),
        OP_SEQ("OP_SEQ", "作业类型序号"),
        TRAN_SEQ("TRAN_SEQ", "交易类型序号"),
        STEP_SEQ("STEP_SEQ", "步骤调用序号"),
        MOVE_ORDER_NO("MOVE_ORDER_NO", "移库单单号"),
        QC_ORDER_NO("QC_ORDER_NO", "质检单单号"),
        CHECK_ORDER_NO("CHECK_ORDER_NO", "盘点主表序号");

        private String code;
        private String description;
        int value;

        COMMON_SEQ(String code, String description) {
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 可选项类型枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OPTION_TYPE {
        OPTIONS(10, "OPTIONS", "可选项"),
        BUTTON(20, "BUTTON", "按钮");

        private String code;
        private String description;
        int value;

        OPTION_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 数据对象枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum DATA_OBJ_TYPE {
        WAREHOUSE(10, "WAREHOUSE", "仓库对象"),
        ZONE(20, "ZONE", "存储区对象"),
        LOCATE(30, "LOCATE", "库位对象"),
        MATERIAL(40, "MATERIAL", "物料对象");

        private String code;
        private String description;
        int value;

        DATA_OBJ_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public String getDescription() {
            return description;
        }
    }

    /**
     * 数据操作枚举
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum DATA_OBJ_OP_TYPE {
        ADD(10, "ADD", "新增"),
        DEL(20, "DEL", "删除"),
        UPD(30, "UPD", "修改"),
        QUERY(40, "QUERY", "查询");

        private String code;
        private String description;
        int value;

        DATA_OBJ_OP_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 库存交易记录生成标记
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TRANS_QUAN_GENERAL_TAG {
        MINUS(-1, "MINUS", "一条：负"), ZERO(0, "ZERO", "一条：0"), PLUS(1, "PLUS", "一条：正"), TWO(2, "TWO", "两条：一正一负");

        private String code;
        private String description;
        int value;

        TRANS_QUAN_GENERAL_TAG(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getCode() {
            return code;
        }

        public String getDescription() {
            return description;
        }

        public static TRANS_QUAN_GENERAL_TAG codeOf(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].code.equals(code)) {
                    return values()[i];
                }
            }
            return null;
        }
    }

    /**
     * 数据状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum DATA_STATUS {
        ENABLE(1, "启用", "fa fa-success cell-fa fa-check"),
        DISABLE(2, "禁用", "fa fa-disabled cell-fa fa-times-circle"),
        LOCKING(3, "全部", "fa cell-fa fa-lock");

        private int value;
        private String description;
        private String code;

        DATA_STATUS(int value, String code, String description){
            this.value = value;
            this.description = description;
            this.code = code;
        }

        public int getValue () {
            return value;
        }

        public String getDescription () {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf (int val){
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].getDescription();
                }
            }
            return tmp;
        }
    }
}
